# coding: utf-8
"""
.. _retrieve-kpn-fax:

Bla Bla bla
=============================

Command per 
utilizzo::

  dj sample

:-d: variabile Booleana per cancellare il messaggi una volta recuperati
:-l: variabile Numero per limitare il numero di messaggi recuperare
:-v: variabile Booleana per visualizzare i print
:-b, --backup: backup messages in 
"""


import re
import os
import sys
import email
import tempfile
import datetime

from django.core.mail.message import EmailMessage
from django.core.management.base import BaseCommand
from django.conf import settings
from django.core import mail

from optparse import make_option
from acomea.ldap import ldap_models

class Command(BaseCommand):
    """Get all messages from configured Host
    """
    help = "Wao!"

    option_list = BaseCommand.option_list + (
        # make_option('-d', '--delete-something', action='store_true', default=False,
        #             dest='delete_messages', help='Delete Something'),
        # make_option('-D', '--debug', action='store_true', default=False,
        #             dest='debug_message', help='Debug '),
        make_option('-u', '--user', help='Uid of user to test'),
        make_option('-p', '--pwd', help='Password to test'),
        # make_option('-f', '--file', dest='filename', help='Read file in argument', default=None),
        make_option('-c','--conn', action='store_true', help='Test connection', default=False),
        # make_option('-b', '--backup', action='store_true', dest='backup',
        #             help='Keep a backup of retrieved email in ...',),
    )

    output_transaction = True

    def handle(self, *args, **options):
        limit = options.get('limit')

        if options.get('conn'):
            try:
                ldap_models.get_conn()
                sys.stderr.write("Ldap conn OK\n")
                return
            except:
                sys.stderr.write("Ldap not reachable at %s\n" % settings.LDAP_SERVER)

        if options.get('user'):
            ldap_user = ldap_models.get_user_by_uid(options.get('user'))
            if not ldap_user:
                sys.stderr.write("No user with uid: %s\n" % options.get('user'))
                return
                
            if ldap_user.validate_password(options.get('pwd')):
                sys.stderr.write("Password is valid\n")
            else:
                sys.stderr.write("Wrong Password\n")
