# -*- coding: utf-8 -*-
from django.conf import settings
from django.utils.translation import ugettext_lazy as _

#: the URI for the LDAP SERVER to conect to. If set to None, 
#: no ldap machinery is started
LDAP_SERVER = 'ldap://localhost'

#: the root dn, default: ``cn=admin,dc=acomea,dc=it``
LDAP_ROOT_DN = 'cn=admin,dc=acomea,dc=it'

#: the password for the root user
LDAP_ROOT_PWD = 'xxx'

# ldap base
LDAP_BASE = 'dc=acomea,dc=it'

#: durata in secondi della sessione condivisa
UTENTI_OTP_AGE = '1800'

#: Id gruppo al quale associare i contatti che vengono creati in fase di login se già presenti in ldap da g5
ACOMEA_LDAP_GROUP_FROM_G5 = 398

